using System;
using System.Reflection;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using DevExpress.XtraEditors;
using DevExpress.XtraEditors.Controls;
using DevExpress.XtraGrid;
using DevExpress.XtraGrid.Views.Grid;
using DevExpress.XtraGrid.Columns;
using DevExpress.Data;
using DevExpress.XtraGrid.Views.Base;
using DevExpress.XtraEditors.Repository;
using System.Collections;
using System.Data.SqlClient;
using CSFramework.Common;


namespace AdvancedSearch
{
    public partial class frmAdvancedSearch : XtraForm
    {
        //ָ֧߼Ľӿ
        private ISupportAdvancedSearch _BLL = null;

        private GridView _OutputView = null;

        //Զ
        private class FieldItem : ItemObject
        {
            private string _TableAlias;

            public FieldItem(string keyName, object value)
                : base(keyName, value)
            {
                _Tag = null;
            }

            public string TableAlias
            {
                get { return _TableAlias; }
                set { _TableAlias = value; }
            }
        }

        private string _CombinedSQL = string.Empty;
        private Control _ValueControl1;
        private Control _ValueControl2;

        public frmAdvancedSearch()
        {
            InitializeComponent();

            _ValueControl1 = txtValue;
            _ValueControl2 = txtValue1;
        }

        private void LoadOperators(bool allowLike, int index)
        {
            if (index == 0)
            {
                cbOperator.Properties.Items.Clear();
                if (cbFields.Text.Trim() != string.Empty)
                {
                    cbOperator.Properties.Items.Add(new ItemObject("", "="));
                    cbOperator.Properties.Items.Add(new ItemObject("ڵ", ">="));
                    cbOperator.Properties.Items.Add(new ItemObject("Сڵ", "<="));
                    cbOperator.Properties.Items.Add(new ItemObject("", "<>"));
                    if (allowLike) cbOperator.Properties.Items.Add(new ItemObject("ƥַ", "like"));
                    cbOperator.SelectedIndex = 0;
                }
            }

            if (index == 1)
            {
                cbOperator1.Properties.Items.Clear();
                if (cbFields1.Text.Trim() != string.Empty)
                {
                    cbOperator1.Properties.Items.Add(new ItemObject("", "="));
                    cbOperator1.Properties.Items.Add(new ItemObject("ڵ", ">="));
                    cbOperator1.Properties.Items.Add(new ItemObject("Сڵ", "<="));
                    cbOperator1.Properties.Items.Add(new ItemObject("", "<>"));
                    if (allowLike) cbOperator1.Properties.Items.Add(new ItemObject("ƥַ", "like"));
                    cbOperator1.SelectedIndex = 0;
                }
            }
        }

        /// <summary>
        /// 򿪸߼ѯ. gridViewгʾֶ. objType:ΪĶ.
        /// </summary>
        public static string Execute(GridView gridView, ISupportAdvancedSearch BLL)
        {
            frmAdvancedSearch form = new frmAdvancedSearch();
            form._BLL = BLL;
            form.InitWindow(gridView);
            form.ShowDialog();
            return form._CombinedSQL;
        }

        public static string Execute(GridView summaryView, GridView detailView, ISupportAdvancedSearch BLL)
        {
            frmAdvancedSearch form = new frmAdvancedSearch();
            form._BLL = BLL;
            form.InitWindow(summaryView, detailView);
            form.ShowDialog();
            return form._CombinedSQL;
        }

        private void InitWindow(GridView gridView)
        {
            _CombinedSQL = string.Empty;
            _OutputView = gridView;

            Object dataSource = gridView.GridControl.DataSource;
            if (dataSource is DataTable)
            {
                ItemObject item = null;
                foreach (GridColumn col in gridView.Columns)
                {
                    item = new ItemObject(col.Caption, col.FieldName);
                    item.Tag = (dataSource as DataTable).Columns[col.FieldName].DataType;
                    cbFields.Properties.Items.Add(item);
                    cbFields1.Properties.Items.Add(item);
                }
                cbFields.Properties.Items.Insert(0, new ItemObject("", ""));
                cbFields1.Properties.Items.Insert(0, new ItemObject("", ""));
            }
        }


        private void InitWindow(GridView summaryView, GridView detailView)
        {
            _OutputView = summaryView;

            object master = summaryView.GridControl.DataSource;
            object detail = summaryView.GridControl.DataSource;

            if ((master is DataTable) && (detail is DataTable) == false) return;

            _CombinedSQL = string.Empty;
            FieldItem item = null;
            foreach (GridColumn col in summaryView.Columns)
            {
                item = new FieldItem(col.Caption, col.FieldName);
                item.Tag = (master as DataTable).Columns[col.FieldName].DataType;
                item.TableAlias = "a."; //
                cbFields.Properties.Items.Add(item);
                cbFields1.Properties.Items.Add(item);
            }

            foreach (GridColumn col in detailView.Columns)
            {
                item = new FieldItem(col.Caption, col.FieldName);
                item.Tag = (detail as DataTable).Columns[col.FieldName].DataType;
                item.TableAlias = "b.";//ϸ
                cbFields.Properties.Items.Add(item);
                cbFields1.Properties.Items.Add(item);
            }

            cbFields.Properties.Items.Insert(0, new ItemObject("", ""));
            cbFields1.Properties.Items.Insert(0, new ItemObject("", ""));

        }

        private void SetValueEditor(Control editor, int index)
        {
            foreach (Control ctl in this.Controls)
            {
                if (ctl.Tag == null) continue;
                if (ctl.Tag.ToString() != "100") continue;
                if (ctl != _ValueControl1 && ctl != _ValueControl2)
                    ctl.Visible = false;
            }

            if (index == 0)
            {
                _ValueControl1.Visible = false;
                _ValueControl1 = editor;
                _ValueControl1.Location = txtValue.Location;
                _ValueControl1.Width = txtValue.Width;
                _ValueControl1.Visible = true;
            }
            else if (index == 1)
            {
                _ValueControl2.Visible = false;
                _ValueControl2 = editor;
                _ValueControl2.Location = txtValue1.Location;
                _ValueControl2.Width = txtValue1.Width;
                _ValueControl2.Visible = true;
            }

            pbAlarm.Visible = false;
            lbAlarm.Visible = false;
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void frmAdvSearch_Load(object sender, EventArgs e)
        {
            if (cbFields.Properties.Items.Count > 0) cbFields.SelectedIndex = 0;

        }

        private string GetOperator(int index)
        {
            ItemObject item = null;
            if (index == 0) item = (ItemObject)cbOperator.SelectedItem;
            if (index == 1) item = (ItemObject)cbOperator1.SelectedItem;
            if (item != null)
                return item.Value.ToString();
            else
                return string.Empty;
        }

        private string GetSQL(ItemObject item, int index)
        {
            string operate = GetOperator(index);
            object value = null;

            Type type = (Type)item.Tag;

            if (index == 0)
            {
                value = _ValueControl1.Text;
            }
            else if (index == 1)
            {
                value = _ValueControl2.Text;
            }

            ////ؿֵ
            //if (value.ToString().Trim() == string.Empty) return " (1=1) ";
            string sql = " (1=1) ";
            if (type == typeof(System.DateTime) && value.ToString().Trim() != string.Empty)
            {
                sql = "(Convert(varchar,{0},112) {1} '{2}')";
                if (item is FieldItem)
                    sql = string.Format(sql, ((FieldItem)item).TableAlias + item.Value, operate, ConvertEx.ToCharYYYYMMDD(DateTime.Parse(value.ToString())));
                else
                    sql = string.Format(sql, item.Value, operate, ConvertEx.ToCharYYYYMMDD(DateTime.Parse(value.ToString())));
            }
            else if (type == typeof(System.String) || type == typeof(System.Char))
            {
                if (operate == "like")
                {
                    if (item is FieldItem)
                        sql = string.Format("({0} {1} '%{2}%')", ((FieldItem)item).TableAlias + item.Value, operate, value);
                    else
                        sql = string.Format("({0} {1} '%{2}%')", item.Value, operate, value);
                }
                else
                {
                    if (item is FieldItem)
                        sql = string.Format("({0} {1} '{2}')", ((FieldItem)item).TableAlias + item.Value, operate, value);
                    else
                        sql = string.Format("({0} {1} '{2}')", item.Value, operate, value);
                }
            }
            else if (IsNum(type))
            {
                if (item is FieldItem)
                    sql = string.Format(" {0}{1}{2}", ((FieldItem)item).TableAlias + item.Value, operate, value.ToString());
                else
                    sql = string.Format(" {0}{1}{2}", item.Value, operate, value.ToString());
            }
            return sql;
        }

        private bool CheckNum(Control editor)
        {
            decimal ret = 0;
            if (!decimal.TryParse(editor.Text, out ret))
            {
                Msg.Warning("Ч!");
                editor.Focus();
                return false;
            }
            return true;
        }

        private string GetCombinedSQL()
        {
            _CombinedSQL = " ({0}{1}{2}) ";
            string sql = " (1=1) ";
            string sql1 = " (1=1) ";
            string logicOperator = " and "; // default is "and"
            if (rbOr.Checked) logicOperator = " or ";

            ItemObject item1 = (ItemObject)cbFields.SelectedItem;
            if (item1 != null)
            {
                Type type1 = (Type)item1.Tag;
                if (IsNum(type1)) if (!CheckNum(_ValueControl1)) return "";
                sql = GetSQL((ItemObject)cbFields.SelectedItem, 0);
            }

            ItemObject item2 = (ItemObject)cbFields1.SelectedItem;
            if (item2 != null)
            {
                Type type2 = (Type)item2.Tag;
                if (IsNum(type2)) if (!CheckNum(_ValueControl2)) return "";
                sql1 = GetSQL((ItemObject)cbFields1.SelectedItem, 1);
            }

            this._CombinedSQL = string.Format(_CombinedSQL, sql, logicOperator, sql1);

            return _CombinedSQL;
        }

        private void OnSelectedIndexChanged(object sender, EventArgs e)
        {//cbOperator
            int index = 0;
            ComboBoxEdit combo = (ComboBoxEdit)sender;
            if (combo == cbFields1) index = 1;
            ItemObject item = (ItemObject)combo.SelectedItem;
            if (item != null)
            {
                Type type = (Type)item.Tag;
                string field = item.Value.ToString().Trim();

                if (type == typeof(System.DateTime))
                {
                    if (index == 0)
                        SetValueEditor(txtDate, index);
                    if (index == 1)
                        SetValueEditor(txtDate1, index);
                    LoadOperators(false, index);
                }
                else if (type == typeof(System.String) || type == typeof(System.Char))
                {
                    Control valueControl = null;
                    if (field.ToUpper().IndexOf("FLAG") == 0)
                    {
                        if (index == 0)
                            valueControl = txtFlag;
                        else
                            valueControl = txtFlag1;
                    }

                    else
                    {
                        if (index == 0)
                            valueControl = txtValue;
                        else
                            valueControl = txtValue1;
                    }
                    SetValueEditor(valueControl, index);
                    LoadOperators(true, index);
                }
                else if (IsNum(type))
                {
                    if (index == 0)
                        SetValueEditor(txtValue, index);
                    if (index == 1)
                        SetValueEditor(txtValue1, index);
                    LoadOperators(false, index);
                }
                else
                {
                    pbAlarm.Visible = true;
                }
            }

            if (index == 0) if (txtValue.CanFocus) txtValue.Focus();
            if (index == 1) if (txtValue1.CanFocus) txtValue1.Focus();
        }

        private bool IsNum(Type type)
        {
            if (type == typeof(System.Decimal) || type == typeof(System.Single)
                || type == typeof(System.Double) || type == typeof(System.Int32))
                return true;
            else
                return false;
        }

        private void btnSearch_Click(object sender, EventArgs e)
        {
            if (_BLL != null)
            {
                string where = GetCombinedSQL();//ϲѯ
                object result = _BLL.AdvancedSearch(where);
                _OutputView.GridControl.DataSource = result;
                Msg.ShowInformation("ѯɹҵ " + _OutputView.RowCount.ToString() + " ¼");
                this.Close();//رմ
            }
            else
            {
                Msg.Warning("δָѯҵ(BLL)");
            }
        }
    }
}

